Apache C++ Standard Library Reference Guide

## Operators

Library: General utilities

- Local Index
- Summary
- Synopsis
- Description
- Standards Conformance

### Local Index

No Entries

### Summary

Operators for the C++ Standard Template Library

### Synopsis

    #include <utility>

    namespace rel_ops {
      template <class T>
      bool operator!=(const T&, const T&);

      template <class T>
      bool operator>(const T&, const T&);

      template <class T>
      bool operator<=(const T&, const T&);

      template <class T>
      bool operator>=(const T&, const T&);
    }

### Description

The STL includes the following operators to avoid redundant definitions of `operator!=` out of `operator==`, and of operators `>`, `<=`, and `>=` out of `operator<`:

`operator!=(x,y)` returns `!(x==y)`

`operator>(x,y)` returns `y>x`

`operator<=(x,y)` returns `!(y<x)`

`operator>=(x,y)` returns `!(x<y)`

To avoid clashes with other global operators, these definitions are contained in the namespace `rel_ops`. To use them, either scope explicitly or include a using declaration, such as `using namespace rel_ops`.

### Standards Conformance

ISO/IEC 14882:1998 -- International Standard for Information Systems -- Programming Language C++, Section 20.2